/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	XPathUtil
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.util;

import java.util.ArrayList;

import javax.xml.transform.TransformerException;

import org.apache.xpath.XPathAPI;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class XPathUtil {

	/** ArrayListからNode[]に変換する為のNode[0] */
	private static Node[] _toSingleArray = new Node[0];

	/** ArrayListからNode[][]に変換する為のNode[0][] */
	private static Node[][] _toDoubleArray = new Node[0][];

	/**
	 * 指定されたノードのノード名からプレフィックスを削除する
	 *
	 * @param node	ノードを指定する
	 * @return プレフィックスを削除したノード名を返却する
	 */
	public static String getLocalName(Node node) {
		String nodeName = node.getNodeName();

		if (nodeName == null) {
			return null;
		}

		int positionOfColon = nodeName.indexOf(':');

		if (positionOfColon == -1) {
			return nodeName;
		}

		return nodeName.substring(positionOfColon + 1);
	}

	/**
	 * nodeで指定されたノードの直下の子供のノードを1つ選択する
	 *
	 * @param	node	検索対象のノードを指定する
	 * @param	xpath	xpath式を指定する。式には以下の物が指定できる<br>
	 *					text()		最初に見つかったTextノードもしくはCDATASectionノードを返却する。<br>
	 *					<pre>@[属性名|*]<pre>	属性名で指定されたAttrノードを返却する。*が指定された場合は
	 *								最初に見つかったAttrノードを返却する。<br>
	 *								プレフィックスの指定はできない。(名前空間は指定できない)<br>
	 *					..			親ノードを返却する。<br>
	 *					.			nodeをを返却する。<br>
	 *					node()		最初に見つかった子ノードを返却する。<br>
	 *					*			最初に見つかったElementノードを返却する。
	 *								プレフィックスの指定はできない。(名前空間は指定できない)<br>
	 *					ノード名	ノード名に一致するElementノードを返却する。
	 *								プレフィックスの指定はできない。(名前空間は指定できない)<br>
	 * @return 見つかったノードを返却する。見つからなかった場合はnullを返却する。
	 */
	public static Node selectSingleChildNode(Node node, String xpath) {
		if (xpath.equals("text()")) {
			NodeList children = node.getChildNodes();

			int numberOfChildren = children.getLength();

			for (int i = 0; i < numberOfChildren; i++) {
				Node n = children.item(i);

				if ((n.getNodeType() == Node.TEXT_NODE) || (n.getNodeType() == Node.CDATA_SECTION_NODE)) {
					return n;
				}
			}

			return null;
		}
		else if (xpath.charAt(0) == '@') {
			String name = xpath.substring(1);

			NamedNodeMap attributes = node.getAttributes();

			if (name.equals("*")) {
				if (attributes.getLength() > 0) {
					return attributes.item(0);
				}

				return null;
			}

			int numberOfAttributes = attributes.getLength();

			for (int i = 0; i < numberOfAttributes; i++) {
				Node n = attributes.item(i);

				if (getLocalName(n).equals(name)) {
					return n;
				}
			}

			return null;
		}
		else if (xpath.equals("..")) {
			return node.getParentNode();
		}
		else if (xpath.equals(".")) {
			return node;
		}
		else if (xpath.equals("node()")) {
			NodeList children = node.getChildNodes();

			if (children.getLength() > 0) {
				return children.item(0);
			}

			return null;
		}
		else if (xpath.equals("*")) {
			NodeList children = node.getChildNodes();

			int numberOfChildren = children.getLength();

			for (int i = 0; i < numberOfChildren; i++) {
				Node n = children.item(i);

				if (n.getNodeType() == Node.ELEMENT_NODE) {
					return n;
				}
			}

			return null;
		}
		else {
			NodeList children = node.getChildNodes();

			int numberOfChildren = children.getLength();

			for (int i = 0; i < numberOfChildren; i++) {
				Node n = children.item(i);

				if (n.getNodeType() == Node.ELEMENT_NODE) {
					if (getLocalName(n).equals(xpath)) {
						return n;
					}
				}
			}

			return null;
		}
	}

	/**
	 * nodeで指定されたノードの直下の子供のノードを選択する
	 *
	 * @param	node	検索対象のノードを指定する
	 * @param	xpath	xpath式を指定する。式には以下の物が指定できる<br>
	 *					text()		見つかったTextノードもしくはCDATASectionノードを全て返却する。<br>
	 *					<pre>@[属性名|*]<pre>	属性名で指定されたAttrノードを返却する。*が指定された場合は
	 *								見つかった全てのAttrノードを返却する。<br>
	 *								プレフィックスの指定はできない。(名前空間は指定できない)<br>
	 *					..			親ノードを返却する。<br>
	 *					.			nodeをを返却する。<br>
	 *					node()		見つかった全ての子ノードを返却する。<br>
	 *					*			全ての見つかったElementノードを返却する。
	 *								プレフィックスの指定はできない。(名前空間は指定できない)<br>
	 *					ノード名	ノード名に一致するElementノードを返却する。
	 *								プレフィックスの指定はできない。(名前空間は指定できない)<br>
	 * @return 見つかったノードをNode[]で返却する。見つからなかった場合はlengthが0のNode[]を返却する。
	 */
	public static Node[] selectChildNodeList(Node node, String xpath) {
		if (xpath.equals("text()")) {
			ArrayList selected = new ArrayList();

			NodeList children = node.getChildNodes();

			int numberOfChildren = children.getLength();

			for (int i = 0; i < numberOfChildren; i++) {
				Node n = children.item(i);

				if ((n.getNodeType() == Node.TEXT_NODE) || (n.getNodeType() == Node.CDATA_SECTION_NODE)) {
					selected.add(n);
				}
			}

			return (Node[])selected.toArray(_toSingleArray);
		}
		else if (xpath.charAt(0) == '@') {
			ArrayList selected = new ArrayList();

			String name = xpath.substring(1);

			NamedNodeMap attributes = node.getAttributes();

			if (name.equals("*")) {
				int numberOfAttributes = attributes.getLength();

				for (int i = 0; i < numberOfAttributes; i++) {
					selected.add(attributes.item(i));
				}
			}
			else {
				int numberOfAttributes = attributes.getLength();

				for (int i = 0; i < numberOfAttributes; i++) {
					Node n = attributes.item(i);

					if (getLocalName(n).equals(name)) {
						selected.add(n);
					}
				}
			}

			return (Node[])selected.toArray(_toSingleArray);
		}
		else if (xpath.equals("..")) {
			return new Node[] { node.getParentNode()};
		}
		else if (xpath.equals(".")) {
			return new Node[] { node };
		}
		else if (xpath.equals("node()")) {
			ArrayList selected = new ArrayList();

			NodeList children = node.getChildNodes();

			int numberOfChildren = children.getLength();

			for (int i = 0; i < numberOfChildren; i++) {
				selected.add(children.item(i));
			}

			return (Node[])selected.toArray(_toSingleArray);
		}
		else if (xpath.equals("*")) {
			ArrayList selected = new ArrayList();

			NodeList children = node.getChildNodes();

			int numberOfChildren = children.getLength();

			for (int i = 0; i < numberOfChildren; i++) {
				Node n = children.item(i);

				if (n.getNodeType() == Node.ELEMENT_NODE) {
					selected.add(n);
				}
			}

			return (Node[])selected.toArray(_toSingleArray);
		}
		else {
			ArrayList selected = new ArrayList();

			NodeList children = node.getChildNodes();

			int numberOfChildren = children.getLength();

			for (int i = 0; i < numberOfChildren; i++) {
				Node n = children.item(i);

				if (n.getNodeType() == Node.ELEMENT_NODE) {
					if (getLocalName(n).equals(xpath)) {
						selected.add(n);
					}
				}
			}

			return (Node[])selected.toArray(_toSingleArray);
		}
	}

	/**
	 * nodeで指定されたノードの直下の子供のノードを1つ選択する。xpathには
	 * 以下の条件の物が指定できる。<br>
	 *
	 * 1.軸の指定は「attribute::」の省略形である「@」のみ指定できる。<br>
	 * 2.ノードテストは指定できない。<br>
	 * 3.ノード以外を返却するxpath式は指定できない。<br>
	 * 4.xpath式に指定するノード式はselectSingleChildNodeメソッドで指定できる式のみ。<br>
	 *
	 * @return 見つかったノードを返却する。見つからなかった場合はnullを返却する。
	 */
	public static Node selectSimpleSingleNode(Node node, String xpath) {
		if (xpath.charAt(0) == '/') {
			if (node.getNodeType() != Node.DOCUMENT_NODE) {
				node = node.getOwnerDocument();
			}

			xpath = xpath.substring(1);

			if (xpath.length() <= 0) {
				return node;
			}
		}

		String[] nodePath = xpath.split("/");

		Node current = node;

		for (int i = 0; i < nodePath.length; i++) {
			current = selectSingleChildNode(current, nodePath[i]);
			if (current == null) {
				break;
			}
		}

		return current;
	}

	/**
	 * nodeで指定されたノードの直下の子供のノードを選択する。xpathには
	 * 以下の条件の物が指定できる。<br>
	 *
	 * 1.軸の指定は「attribute::」の省略形である「@」のみ指定できる。<br>
	 * 2.ノードテストは指定できない。<br>
	 * 3.ノード以外を返却するxpath式は指定できない。<br>
	 * 4.xpath式に指定するノード式はselectChildNodeListメソッドで指定できる式のみ。<br>
	 *
	 * @return 見つかったノードをNode[]で返却する。見つからなかった場合はlengthが0のNode[]を返却する。
	 */
	public static Node[] selectSimpleNodeList(Node node, String xpath) {
		if (xpath.charAt(0) == '/') {
			if (node.getNodeType() != Node.DOCUMENT_NODE) {
				node = node.getOwnerDocument();
			}

			xpath = xpath.substring(1);

			if (xpath.length() <= 0) {
				return new Node[] { node };
			}
		}

		String[] nodePath = xpath.split("/");

		Node[][] current = { { node }, };

		ArrayList selected = new ArrayList();

		for (int i = 0; i < nodePath.length; i++) {
			for (int j = 0; j < current.length; j++) {
				for (int k = 0; k < current[j].length; k++) {
					selected.add(selectChildNodeList(current[j][k], nodePath[i]));
				}
			}

			current = (Node[][])selected.toArray(_toDoubleArray);
			selected.clear();
		}

		for (int i = 0; i < current.length; i++) {
			for (int j = 0; j < current[i].length; j++) {
				selected.add(current[i][j]);
			}
		}

		return (Node[])selected.toArray(_toSingleArray);
	}

	/**
	 * XPathAPI#selectSingleNodeを使用し、ノードの検索を行う
	 *
	 * @param node	ノードを指定する
	 * @param xpath	XPath式を指定する
	 * @return XPathAPI#selectSingleNodeでの検索結果
	 */
	public static Node selectSingleNode(Node node, String xpath) throws TransformerException {
		synchronized (XPathAPI.class) {
			return XPathAPI.selectSingleNode(node, xpath);
		}
	}

	/**
	 * XPathAPI#selectNodeListを使用し、ノードの検索を行う
	 *
	 * @param node	ノードを指定する
	 * @param xpath	XPath式を指定する
	 * @return XPathAPI#selectNodeListでの検索結果
	 */
	public static Node[] selectNodeList(Node node, String xpath) throws TransformerException {
		synchronized (XPathAPI.class) {
			NodeList nodeList = XPathAPI.selectNodeList(node, xpath);

			if (nodeList == null) {
				return null;
			}

			Node[] nodes = new Node[nodeList.getLength()];

			for (int i = 0; i < nodes.length; i++) {
				nodes[i] = nodeList.item(i);
			}

			return nodes;
		}
	}
}
